//+------------------------------------------------------------------+
//|                                                 birt's patch.mq4 |
//|                                                             birt |
//|                                              http://eareview.net |
//+------------------------------------------------------------------+
/*
    Copyright (C) 2009-2011 Cristi Dumitrescu <birt@eareview.net>
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#property copyright "birt"
#property link      "http://eareview.net"
#property show_inputs

extern bool NoFXTOverwrite = true;
extern string WARNING1 = "The 2GB limit removal only works in Windows 7 and Vista.";
extern bool Remove2GBLimit = true;
extern string WARNING2 = "Using variable spread with a non-variable spread FXT does NOT work.";
extern bool RealSpread = false;

#define MEM_COMMIT 0x1000
#define PAGE_EXECUTE_READWRITE 0x40
#define MAX_PATH 260

#define LAST_BUILD_KNOWN 406

#import "kernel32.dll"
   int  GetCurrentProcess();
   int  WriteProcessMemory(int handle, int address, int& buffer[], int size, int& written);
   int  ReadProcessMemory(int handle, int address, int& buffer[], int size, int& read);
   int  LoadLibraryA(string file);
   int  GetProcAddress(int hmodule, string procname);
   int  VirtualAlloc(int addr, int size, int type, int protect);
   int  GetModuleHandleA(int modName);
   int  GetModuleFileNameA(int hmod, int &buffer[], int len);
#import "Version.dll"
   int  GetFileVersionInfoSizeA(int &filename[], int h);
   bool GetFileVersionInfoA(int &filename[], int h, int len, int& lpData[]);
#import

int mt4build = 0;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   mt4build = MT4build();
   Print("MT4 build " + mt4build + " detected.");
   if (mt4build > LAST_BUILD_KNOWN) {
      Print("The patch you are running was not tested with this build so it may or may not work.");
      Print("You should check for a new patch at http://eareview.net/tick-data");
   }
   if (NoFXTOverwrite) fxtpatch();
   if (Remove2GBLimit) gblimit();
   if (RealSpread) spread();
//----
   return(0);
  }
//+------------------------------------------------------------------+

void fxtpatch() {
/*
.text:00540E75 83 C4 1C                                add     esp, 1Ch
.text:00540E78 85 C0                                   test    eax, eax
.text:00540E7A 0F 85 EE 02 00 00                       jnz     loc_54116E
*/
   int search1[] = { 0x83, 0xc4, 0x1c, 0x85, 0xc0, 0x0f, 0x85 };
/*
.text:00540F92 1B C0                                   sbb     eax, eax
.text:00540F94 83 D8 FF                                sbb     eax, 0FFFFFFFFh
.text:00540F97 85 C0                                   test    eax, eax
.text:00540F99 0F 85 9D 01 00 00                       jnz     loc_54113C
*/
   int search2[] = { 0x1b, 0xc0, 0x83, 0xd8, 0xff, 0x85, 0xc0, 0x0f, 0x85, 0x9d, 0x01, 0x00, 0x00 };
   // builds 405+
   int search2a[] = { 0x1b, 0xc0, 0x83, 0xd8, 0xff, 0x85, 0xc0, 0x0f, 0x85, 0x9b, 0x01, 0x00, 0x00 };
/*
.text:0054109A 8B 42 18                                mov     eax, [edx+18h]
.text:0054109D 85 C0                                   test    eax, eax
.text:0054109F 0F 85 97 00 00 00                       jnz     loc_54113C
*/
   int search3[] = { 0x8b, 0x42, 0x18, 0x85, 0xc0, 0x0f, 0x85 };
   int patchaddr1 = FindMemory(0x510000, 0x570000, search1);
   if (patchaddr1 != 0) {
      int patchaddr2 = FindMemory(patchaddr1, patchaddr1 + 32768, search2);
      if (patchaddr2 == 0) {
         patchaddr2 = FindMemory(patchaddr1, patchaddr1 + 32768, search2a);
      }
      int patchaddr3 = FindMemory(patchaddr1, patchaddr1 + 32768, search3);
   }
   if (patchaddr1 != 0 && patchaddr2 != 0 && patchaddr3 != 0) {
      int patch[] = { 0x00, 0x00 };
      PatchZone(patchaddr1 + 7, patch);
      PatchZone(patchaddr2 + 9, patch);
      PatchZone(patchaddr3 + 7, patch);
      Print("FXT overwriting disabled. Addresses patched: 0x" + Dec2Hex(patchaddr1) + ", 0x" + Dec2Hex(patchaddr2) + ", 0x" + Dec2Hex(patchaddr3) + ".");
   }
   else {
      Print("FXT overwriting already disabled or unable to find the location to patch.");
   }
}

int ProcessPatch(int address, int byte)
{
   int mem[1];
   int out;
   mem[0] = byte;
   int hproc = GetCurrentProcess();
   int result = WriteProcessMemory(hproc, address, mem, 1, out);
   return (result);
}

void PatchZone(int address, int patch[]) {
   int mem[1];
   int out;
   int hproc = GetCurrentProcess();
   for (int i = 0; i < ArraySize(patch); i++) {
      mem[0] = patch[i];
      WriteProcessMemory(hproc, address + i, mem, 1, out);
   }
   return(0);
}

int FindMemory(int start, int end, int cmp[]) {
   int mem[1];
   int out;
   int hproc = GetCurrentProcess();
   for (int i = start; i <= end; i++) {
      mem[0] = 0;
      ReadProcessMemory(hproc, i, mem, 1, out);
      if (mem[0] == cmp[0]) {
         bool found = true;
         for (int j = 1; j < ArraySize(cmp); j++) {
            mem[0] = 0;
            ReadProcessMemory(hproc, i + j, mem, 1, out);
            if (mem[0] != cmp[j]) {
               found = false;
               break;
            }
         }
         if (found) return (i);
      }
   }
   return(0);
}

void ReadDword(int addr, int& arr[]) {
   int mem[1];
   int out;
   int hproc = GetCurrentProcess();
   ReadProcessMemory(hproc, addr, mem, 1, out);
   arr[0] = mem[0];
   ReadProcessMemory(hproc, addr + 1, mem, 1, out);
   arr[1] = mem[0];
   ReadProcessMemory(hproc, addr + 2, mem, 1, out);
   arr[2] = mem[0];
   ReadProcessMemory(hproc, addr + 3, mem, 1, out);
   arr[3] = mem[0];
}

void StoreDword(int addr, int& arr[]) {
   arr[0] = addr & 0xFF;
   arr[1] = (addr & 0xFF00) >> 8;
   arr[2] = (addr & 0xFF0000) >> 16;
   arr[3] = (addr & 0xFF000000) >> 24;
}

/*
// Probably should've checked if regular fseek works over 2GB using SEEK_SET *before* implementing this solution...
void gblimit() {
/*
// 225 (similar up to 392)
.text:00541426 8B 86 F0 02 00 00       mov     eax, [esi+2F0h]
.text:0054142C 8B 8E D8 02 00 00       mov     ecx, [esi+2D8h]
.text:00541432 83 C0 0E                add     eax, 0Eh
.text:00541435 53                      push    ebx             ; Origin
.text:00541436 8D 14 40                lea     edx, [eax+eax*2]
.text:00541439 8D 04 90                lea     eax, [eax+edx*4]
.text:0054143C C1 E0 02                shl     eax, 2
.text:0054143F 50                      push    eax             ; Offset
.text:00541440 51                      push    ecx             ; File
.text:00541441 FF 15 98 4D 56 00       call    ds:fsee
*/
/*
   int search[] = { 0x8d, 0x14, 0x40, 0x8d, 0x04, 0x90, 0xc1, 0xe0, 0x02, 0x50, 0x51 };
   int patcharea = FindMemory(0x510000, 0x570000, search);
   int patchaddr;
   bool ff15call = false;
   if (patcharea != 0) {
      patchaddr = patcharea + 11;
   }
   else {
/*
// 399 (similar up to 402)
.text:00547097 8D 0C 40                          lea     ecx, [eax+eax*2]
.text:0054709A 8D 14 88                          lea     edx, [eax+ecx*4]
.text:0054709D 8B 86 D8 02 00 00                 mov     eax, [esi+2D8h]
.text:005470A3 C1 E2 02                          shl     edx, 2
.text:005470A6 52                                push    edx
.text:005470A7 50                                push    eax
.text:005470A8 FF 15 38 AE 56 00                 call    ds:fseek
*/
/*
      int search2[] = { 0x8d, 0x0c, 0x40, 0x8d, 0x14, 0x88, 0x8b, 0x86, 0xd8, 0x02, 0x00, 0xc1, 0xe2, 0x02, 0x52, 0x50, 0xff };
      patcharea = FindMemory(0x510000, 0x570000, search2);
      if (patcharea != 0) {
         patchaddr = patcharea + 15;
      }
      else {
/*
// 406 (405 as well)
.text:00556B84 8D 14 40                          lea     edx, [eax+eax*2]
.text:00556B87 8D 04 90                          lea     eax, [eax+edx*4]
.text:00556B8A 53                                push    ebx
.text:00556B8B C1 E0 02                          shl     eax, 2
.text:00556B8E 50                                push    eax
.text:00556B8F 51                                push    ecx
.text:00556B90 E8 4D B5 02 00                    call    fseek
*/
/*
         int search3[] = { 0x8d, 0x14, 0x40, 0x8d, 0x04, 0x90, 0x53, 0xc1, 0xe0, 0x02, 0x50, 0x51 };
         patcharea = FindMemory(0x510000, 0x570000, search3);
         if (patcharea != 0) {
            ff15call = false;
            patchaddr = patcharea + 11;
         }
      }
   }
   if (patcharea == 0) {
      Print("2GB limit patch already applied or just can't find the memory area to patch it.");
      if (mt4build > LAST_BUILD_KNOWN) {
         Print("Check http://eareview.net for a newer version of this script if the patch was not previously applied.");
      }
      return;   
   }
   int b[4];
   ReadDword(patchaddr, b);
   if (b[0] == 0xff) {
      ff15call = true;
      patchaddr += 2;
   }
   else if (b[0] == 0xe8) {
      ff15call = true;
      patchaddr += 1;
   }
   else {
      Print("Unexpected data found while trying to patch the 2GB limit. Aborting.");
      return;
   }
   int calcbase = patchaddr + 4;
   ReadDword(patchaddr, b);
   int callAddress = b[0] + b[1] * 256 + b[2] * 256 * 256 + b[3] * 256 * 256 * 256;
   if (!ff15call) {
      callAddress += calcbase;
   }
   if (callAddress > 0x800000) {
      Print("Looks like the 2GB patch was already applied. Cancelling.");
      return;   
   }
   Print("callAddress: 0x" + Dec2Hex(callAddress));
   int new = VirtualAlloc(0, 256, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
   Print("Patch address found: 0x" + Dec2Hex(patcharea) + ". 2gb limit removal patch is being installed at 0x" + Dec2Hex(new) + ".");
   int callBaseModAddr = patchaddr - 1;
   if (ff15call) {
      callBaseModAddr--;
   }
   ProcessPatch(callBaseModAddr, 0xe8); // change to call relative
   calcbase = callBaseModAddr + 5;
   int offset = new - calcbase;
   StoreDword(offset, b);
   PatchZone(callBaseModAddr + 1, b);
   if (ff15call) { // add a nop if needed
      ProcessPatch(callBaseModAddr + 5, 0x90);
   }
/*
01850000     E8 00000000               CALL 01850005
01850005     59                        POP ECX                                         ; allocated memory + 5
01850006     58                        POP EAX                                         ; return address
01850007     8981 C8000000             MOV DWORD PTR DS:[ECX+C8],EAX                   ; save the return address
0185000D     8B86 F0020000             MOV EAX,DWORD PTR DS:[ESI+2F0]                  ; fetch the current number of records
01850013     85C0                      TEST EAX,EAX
01850015     74 17                     JE SHORT 0185002E                               ; just perform a regular fseek if it's the first operation
01850017     2B81 CC000000             SUB EAX,DWORD PTR DS:[ECX+CC]                   ; subtract previously stored number of records
0185001D     53                        PUSH EBX
0185001E     BB 34000000               MOV EBX,34
01850023     F7E3                      MUL EBX
01850025     5B                        POP EBX                                         ; msvcrt.77C5FD00
01850026     FE4424 08                 INC BYTE PTR SS:[ESP+8]                         ; use SEEK_CUR instead of SEEK_SET
0185002A     894424 04                 MOV DWORD PTR SS:[ESP+4],EAX                    ; save the new seek length
0185002E     8B86 F0020000             MOV EAX,DWORD PTR DS:[ESI+2F0]                  ; retrieve the current number of records once more
01850034     8981 CC000000             MOV DWORD PTR DS:[ECX+CC],EAX                   ; save the number of records for the next time
0185003A     FF15 984D5600             CALL DWORD PTR DS:[<&MSVCRT.fseek>]             ; msvcrt.fseek
01850040     E8 00000000               CALL 01850045
01850045     59                        POP ECX                                         
01850046     83E9 40                   SUB ECX,40
01850049     8B89 C8000000             MOV ECX,DWORD PTR DS:[ECX+C8]
0185004F   - FFE1                      JMP ECX                                         
*/
/*
   int patch[] = { 0xe8, 0x00, 0x00, 0x00, 0x00,
                     0x59, 0x58,
                     0x89, 0x81, 0xc8, 0x00, 0x00, 0x00,
                     0x8b, 0x86, 0xf0, 0x02, 0x00, 0x00,
                     0x85, 0xc0,
                     0x74, 0x17,
                     0x2b, 0x81, 0xcc, 0x00, 0x00, 0x00,
                     0x53,
                     0xbb, 0x34, 0x00, 0x00, 0x00,
                     0xf7, 0xe3, 0x5b,
                     0xfe, 0x44, 0x24, 0x08,
                     0x89, 0x44, 0x24, 0x04,
                     0x8b, 0x86, 0xf0, 0x02, 0x00, 0x00,
                     0x89, 0x81, 0xcc, 0x00, 0x00, 0x00,
                     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // ff15/e8 call
                     0xe8, 0x00, 0x00, 0x00, 0x00,
                     0x59, 0x83, 0xe9, 0x40,
                     0x8b, 0x89, 0xc8, 0x00, 0x00, 0x00,
                     0xff, 0xe1 };
   PatchZone(new, patch);
   int newCallAddr = new + 0x3A;
   if (ff15call) {
      ProcessPatch(newCallAddr + 0, 0xff);
      ProcessPatch(newCallAddr + 1, 0x15);
      StoreDword(callAddress, b);
      PatchZone(newCallAddr + 2, b);
   }
   else {
      ProcessPatch(newCallAddr, 0xe8);
      calcbase = newCallAddr + 5;
      offset = callAddress - calcbase;
      StoreDword(offset, b);
      PatchZone(newCallAddr + 1, b);
      ProcessPatch(newCallAddr + 5, 0x90); // extra nop
   }
}
*/

void gblimit() {
   int h;
   int addr1 = 0;
   int addr2 = 0;
   h = LoadLibraryA("ntdll.dll");
   if (h != 0) addr2 = GetProcAddress(h, "_allmul");
   if (addr2 == 0) {
      Alert("2GB limit removal not activated.");
      Alert("Could not find the _allmul function in ntdll.dll.");
      return(0);
   }
   if (mt4build < 399) {
      string lib = "msvcrt.dll";
      h = LoadLibraryA(lib);
      if (h != 0) addr1 = GetProcAddress(h, "_fseeki64");
      if (addr1 == 0) {
         Alert("The 2GB limit removal for this build works only in Windows 7, Vista and Server 2008.");
         Alert("2GB limit removal not activated.");
         Alert("Could not find the _fseeki64() function in your msvcrt.dll!");
         return(0);
      }
/*
.text:00541436 8D 14 40                                lea     edx, [eax+eax*2]
.text:00541439 8D 04 90                                lea     eax, [eax+edx*4]
.text:0054143C C1 E0 02                                shl     eax, 2
.text:0054143F 50                                      push    eax             ; Offset
.text:00541440 51                                      push    ecx             ; File
.text:00541441 FF 15 98 4D 56 00                       call    ds:fseek // themida messes it up in 226+
*/
      int search[] = { 0x8d, 0x14, 0x40, 0x8d, 0x04, 0x90, 0xc1, 0xe0, 0x02, 0x50, 0x51 };
      int patcharea = FindMemory(0x510000, 0x570000, search);
      if (patcharea == 0) {
         Print("Process already patched for the 2gb limit removal or we just can't find the area to patch.");
         return;
      }
      int patchaddr = patcharea;
      int calcbase = patchaddr + 5;
/*
.text:0054144C 74 0A                                   jz      short loc_541458
*/
      int search2[] = { 0x74, 0x0A };
      int returnaddr = FindMemory(patcharea, patchaddr + 1024, search2);
   
      if (returnaddr == 0) {
         Print("Can't locate return address for 2gb patch limit removal, skipping patch.");
         return;
      }
   
      ProcessPatch(patchaddr, 0xe9);
      int new = VirtualAlloc(0, 256, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
      Print("Patch address found: 0x" + Dec2Hex(patcharea) + ". 2gb limit removal patch is being installed at 0x" + Dec2Hex(new) + ".");
      int offset = new - calcbase;
      int b[4];
      StoreDword(offset, b);
      PatchZone(patchaddr + 1, b);

/*
.0054116E: 51                             push        ecx
.0054116F: 6A00                           push        0
.00541171: 50                             push        eax
.00541172: 6A00                           push        0
.00541174: 6A34                           push        34
.00541176: FF15A0115400                   call        d,[0005411A0]
.0054117C: 59                             pop         ecx
.0054117D: 52                             push        edx
.0054117E: 50                             push        eax
.0054117F: 51                             push        ecx
.00541180: FF15A4115400                   call        d,[0005411A4]
.00541186: 83C410                         add         esp,00C
.00541189: 85C0                           test        eax,eax
.0054118B: E93C0E0000                     jmp        .000541FCC
*/
      int patch[] = {0x51, 0x6a, 0x00, 0x50, 0x6a, 0x00, 0x6a, 0x34,
                      0xff, 0x15, 0xa0, 0x11, 0x54, 0x00,
                      0x59, 0x52, 0x50, 0x51,
                      0xff, 0x15, 0xa4, 0x11, 0x54, 0x00,
                      0x83, 0xc4, 0x0C,
                      0x85, 0xc0,
                      0xe9};
      PatchZone(new, patch);
      StoreDword(addr1, b);
      PatchZone(new + 128, b); // _fseeki64 goes at the alloced memory area + 128
      StoreDword(addr2, b);
      PatchZone(new + 132, b); // _allmul goes at the alloced memory area + 132
      StoreDword(new + 132, b);
      PatchZone(new + 10, b); // fix the _allmul call
      StoreDword(new + 128, b);
      PatchZone(new + 20, b); // fix the _fseeki64 call
      offset = returnaddr - (new + 30 + 4);
      StoreDword(offset, b);
      PatchZone(new + 30, b); // fix the returning jump
   }
   else if (mt4build <= 402) {
      lib = "msvcrt.dll";
      h = LoadLibraryA(lib);
      if (h != 0) addr1 = GetProcAddress(h, "_fseeki64");
      if (addr1 == 0) {
         Alert("The 2GB limit removal for this build works only in Windows 7, Vista and Server 2008.");
         Alert("2GB limit removal not activated.");
         Alert("Could not find the _fseeki64() function in your msvcrt.dll!");
         return(0);
      }
/*
build 399:
.text:00547097 8D 0C 40                          lea     ecx, [eax+eax*2]
.text:0054709A 8D 14 88                          lea     edx, [eax+ecx*4]
.text:0054709D 8B 86 D8 02 00 00                 mov     eax, [esi+2D8h]
.text:005470A3 C1 E2 02                          shl     edx, 2
.text:005470A6 52                                push    edx
.text:005470A7 50                                push    eax
.text:005470A8 FF 15 38 AE 56 00                 call    ds:fseek
.text:005470AE 83 C4 0C                          add     esp, 0Ch
.text:005470B1 85 C0                             test    eax, eax
.text:005470B3 74 0A                             jz      short loc_5470BF
*/
      int search3[] = { 0x8d, 0x0c, 0x40, 0x8d, 0x14, 0x88, 0x8b, 0x86, 0xd8, 0x02, 0x00 };
      patcharea = FindMemory(0x510000, 0x570000, search3);
      if (patcharea == 0) {
         Print("Process already patched for the 2gb limit removal or we just can't find the area to patch.");
         return;
      }
      patchaddr = patcharea;
      calcbase = patchaddr + 5;
      int search4[] = { 0x74, 0x0A };
      returnaddr = FindMemory(patcharea, patchaddr + 1024, search4);
      if (returnaddr == 0) {
         Print("Can't locate return address for 2gb patch limit removal, skipping patch.");
         return;
      }
   
      ProcessPatch(patchaddr, 0xe9);
      new = VirtualAlloc(0, 256, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
      Print("Patch address found: 0x" + Dec2Hex(patcharea) + ". 2gb limit removal patch is being installed at 0x" + Dec2Hex(new) + ".");
      offset = new - calcbase;
      StoreDword(offset, b);
      PatchZone(patchaddr + 1, b); // fix jump
      
/*
.005475E7: 6A00                           push        0
.005475E9: 50                             push        eax
.005475EA: 6A00                           push        0
.005475EC: 6A34                           push        034 ;'4'
.005475EE: FF1500000000                   call        d,[0] --?3
.005475F4: 52                             push        edx
.005475F5: 50                             push        eax
.005475F6: 8B86D8020000                   mov         eax,[esi][0000002D8]
.005475FC: 50                             push        eax
.005475FD: FF1500000000                   call        d,[0] --?3
.00547603: 83C410                         add         esp,010
.00547606: 85C0                           test        eax,eax
.00547608: E900000000                     jmp        .00054760D --?4
*/
      int patch1[] = {  0x6a, 0x00, 0x50, 0x6a, 0x00, 0x6a, 0x34,
                        0xff, 0x15, 0x00, 0x00, 0x00, 0x00,
                        0x52, 0x50,
                        0x8b, 0x86, 0xd8, 0x02, 0x00, 0x00,
                        0x50,
                        0xff, 0x15, 0x00, 0x00, 0x00, 0x00,
                        0x83, 0xc4, 0x10,
                        0x85, 0xc0,
                        0xe9, 0x00, 0x00, 0x00, 0x00 };
      PatchZone(new, patch1);
      StoreDword(addr1, b);
      PatchZone(new + 128, b); // _fseeki64 goes at the alloced memory area + 128
      StoreDword(addr2, b);
      PatchZone(new + 132, b); // _allmul goes at the alloced memory area + 132
      StoreDword(new + 132, b);
      PatchZone(new + 9, b); // fix the _allmul call
      StoreDword(new + 128, b);
      PatchZone(new + 24, b); // fix the _fseeki64 call
      offset = returnaddr - (new + ArraySize(patch1));
      StoreDword(offset, b);
      PatchZone(new + ArraySize(patch1) - 4, b); // fix the returning jump
   }
   else { // 405+
      lib = "msvcrt.dll";
      h = LoadLibraryA(lib);
      if (h != 0) int fseeki64 = GetProcAddress(h, "_fseeki64");
      if (fseeki64 == 0) {
         lib = "msvcr80.dll";
         h = LoadLibraryA(lib);
         if (h != 0) fseeki64 = GetProcAddress(h, "_fseeki64");
      }
      if (fseeki64 == 0) {
         lib = "msvcr90.dll";
         h = LoadLibraryA(lib);
         if (h != 0) fseeki64 = GetProcAddress(h, "_fseeki64");
      }
      if (fseeki64 == 0) {
         lib = "msvcr100.dll";
         h = LoadLibraryA(lib);
         if (h != 0) fseeki64 = GetProcAddress(h, "_fseeki64");
      }
      if (fseeki64 == 0) {
         Alert("Could not find the _fseeki64() function in your msvcrt.dll or msvcr100.dll!");
         Alert("If you're using Windows XP, consider getting a copy of the Visual C 2010 runtime, available at http://www.microsoft.com/download/en/details.aspx?id=5555 (x86) and http://www.microsoft.com/download/en/details.aspx?id=14632 (x64).");
         Alert("2GB limit removal not activated.");
         return(0);
      }
      int filelength = GetProcAddress(h, "_filelength");
      int fopen = GetProcAddress(h, "fopen");
      int fclose = GetProcAddress(h, "fclose");
      int fread = GetProcAddress(h, "fread");
/*
.text:00556B84 8D 14 40                          lea     edx, [eax+eax*2]
.text:00556B87 8D 04 90                          lea     eax, [eax+edx*4]
.text:00556B8A 53                                push    ebx
.text:00556B8B C1 E0 02                          shl     eax, 2
.text:00556B8E 50                                push    eax
.text:00556B8F 51                                push    ecx
.text:00556B90 E8 4D B5 02 00                    call    fseek
*/
      int search5[] = { 0x8d, 0x14, 0x40, 0x8d, 0x04, 0x90, 0x53, 0xc1, 0xe0, 0x02, 0x50, 0x51 };
      patcharea = FindMemory(0x510000, 0x570000, search5);
      if (patcharea == 0) {
         Print("Process already patched for the 2gb limit removal or we just can't find the area to patch.");
         return;
      }
      
/*
// test
      int fseek = GetProcAddress(h, "fseek");
      if (patcharea == 0) {
         Alert("Failed to fully patch the 2GB limit!");
         Alert("Backtesting will probably result in a crash!");
         return;
      }
      Print("Patcharea: 0x" +Dec2Hex(patcharea));
      patcharea += 17;
      offset = fseek - patcharea;
      patcharea -= 4;
      StoreDword(offset, b);
      PatchZone(patcharea, b);
*/
      
      patchaddr = patcharea;
      calcbase = patchaddr + 6;
/*
.text:0054144C 74 0A                                   jz      short loc_541458
*/
      int search6[] = { 0x74, 0x0A };
      returnaddr = FindMemory(patcharea, patchaddr + 1024, search6);
   
      if (returnaddr == 0) {
         Print("Can't locate return address for 2gb patch limit removal, skipping patch.");
         return;
      }

      ProcessPatch(patchaddr, 0x53);   
      ProcessPatch(patchaddr + 1, 0xe9);
      new = VirtualAlloc(0, 256, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
      Print("Patch address found: 0x" + Dec2Hex(patcharea) + ". 2gb limit removal patch is being installed at 0x" + Dec2Hex(new) + ".");
      offset = new - calcbase;
      StoreDword(offset, b);
      PatchZone(patchaddr + 2, b);

/*
.0054116E: 51                             push        ecx
.0054116F: 6A00                           push        0
.00541171: 50                             push        eax
.00541172: 6A00                           push        0
.00541174: 6A34                           push        34
.00541176: FF15A0115400                   call        d,[0005411A0]
.0054117C: 59                             pop         ecx
.0054117D: 52                             push        edx
.0054117E: 50                             push        eax
.0054117F: 51                             push        ecx
.00541180: FF15A4115400                   call        d,[0005411A4]
.00541186: 83C410                         add         esp,010
.00541189: 85C0                           test        eax,eax
.0054118B: E93C0E0000                     jmp        .000541FCC
*/
      int patch3[] = {0x51, 0x6a, 0x00, 0x50, 0x6a, 0x00, 0x6a, 0x34,
                      0xff, 0x15, 0xa0, 0x11, 0x54, 0x00,
                      0x59, 0x52, 0x50, 0x51,
                      0xff, 0x15, 0xa4, 0x11, 0x54, 0x00,
                      0x83, 0xc4, 0x10,
                      0x85, 0xc0,
                      0xe9};
      PatchZone(new, patch3);
      StoreDword(fseeki64, b);
      PatchZone(new + 128, b); // _fseeki64 goes at the alloced memory area + 128
      StoreDword(addr2, b);
      PatchZone(new + 132, b); // _allmul goes at the alloced memory area + 132
      StoreDword(new + 132, b);
      PatchZone(new + 10, b); // fix the _allmul call
      StoreDword(new + 128, b);
      PatchZone(new + 20, b); // fix the _fseeki64 call
      offset = returnaddr - (new + 30 + 4);
      StoreDword(offset, b);
      PatchZone(new + 30, b); // fix the returning jump

/*
406:
.text:00556A94 E8 CF AE 02 00                    call    fopen
.text:00556A99 83 C4 24                          add     esp, 24h
.text:00556A9C 3B C3                             cmp     eax, ebx
.text:00556A9E 89 86 D8 02 00 00                 mov     [esi+2D8h], eax
.text:00556AA4 75 23                             jnz     short loc_556AC9
*/
      int search7[] = { 0x83, 0xc4, 0x24, 0x3b, 0xc3, 0x89, 0x86, 0xd8, 0x02, 0x00, 0x00 };
      patcharea = FindMemory(0x510000, 0x570000, search7);
      if (patcharea == 0) {
         Alert("Failed to fully patch the 2GB limit!");
         Alert("Backtesting will probably result in a crash!");
         return;
      }
      offset = fopen - patcharea;
      patcharea -= 4;
      StoreDword(offset, b);
      PatchZone(patcharea, b);
/*
406:      
.text:005412FE FF 15 94 4D 56 00                       call    ds:fclose
.text:00541304 83 C4 04                                add     esp, 4
.text:00541307 89 9E D8 02 00 00                       mov     [esi+2D8h], ebx
.text:0054130D 8B 86 04 03 00 00                       mov     eax, [esi+304h]
*/
      int search8[] = { 0x83, 0xc4, 0x04, 0x89, 0x9e, 0xd8, 0x02, 0x00, 0x00, 0x8b, 0x86, 0x04, 0x03, 0x00, 0x00 };
      patcharea = FindMemory(0x510000, 0x570000, search8);
      if (patcharea == 0) {
         Alert("Failed to fully patch the 2GB limit!");
         Alert("Backtesting will probably result in a crash!");
         return;
      }
      offset = fclose - patcharea;
      patcharea -= 4;
      StoreDword(offset, b);
      PatchZone(patcharea, b);
/*
406:
.text:00556BCD 8D 04 7F                          lea     eax, [edi+edi*2]
.text:00556BD0 8D 0C 87                          lea     ecx, [edi+eax*4]
.text:00556BD3 6A 01                             push    1
.text:00556BD5 C1 E1 02                          shl     ecx, 2
.text:00556BD8 51                                push    ecx
.text:00556BD9 52                                push    edx
.text:00556BDA E8 26 AE 02 00                    call    fread
*/
      int search9[] = { 0x8d, 0x04, 0x7f, 0x8d, 0x0c, 0x87, 0x6a, 0x01, 0xc1, 0xe1, 0x02, 0x51, 0x52, 0xe8 };
      patcharea = FindMemory(0x510000, 0x570000, search9);
      if (patcharea == 0) {
         Alert("Failed to fully patch the 2GB limit!");
         Alert("Backtesting will probably result in a crash!");
         return;
      }
      patcharea += 18;
      offset = fread - patcharea;
      patcharea -= 4;
      StoreDword(offset, b);
      PatchZone(patcharea, b);
/*
.text:00556ACD E8 A9 AE 02 00                    call    _filelength
.text:00556AD2 8B C8                             mov     ecx, eax
.text:00556AD4 81 E9 D8 02 00 00                 sub     ecx, 2D8h
.text:00556ADA B8 4F EC C4 4E                    mov     eax, 4EC4EC4Fh
.text:00556ADF F7 E1                             mul     ecx
.text:00556AE1 83 C4 04                          add     esp, 4
.text:00556AE4 C1 EA 04                          shr     edx, 4
.text:00556AE7 89 96 F4 02 00 00                 mov     [esi+2F4h], edx
*/
      int search10[] = { 0x8b, 0xc8, 0x81, 0xe9, 0xd8, 0x02, 0x00, 0x00, 0xb8, 0x4f, 0xec, 0xc4, 0x4e, 0xf7, 0xe1, 0x83, 0xc4, 0x04 };
      patcharea = FindMemory(0x510000, 0x570000, search10);
      if (patcharea == 0) {
         Alert("Failed to fully patch the 2GB limit!");
         Alert("Backtesting will probably result in a crash!");
         return;
      }
      offset = filelength - patcharea;
      patcharea -= 4;
      StoreDword(offset, b);
      PatchZone(patcharea, b);
   }
}

void spread() {
/*
.text:00541D80 8B 93 F8 02 00 00                       mov     edx, [ebx+2F8h] // 0x2e8 in b225
.text:00541D86 DD 42 1C                                fld     qword ptr [edx+1Ch]
.text:00541D89 DC 83 20 03 00 00                       fadd    qword ptr [ebx+320h]
*/
   int search[] = { 0x02, 0x00, 0x00,
                    0xdd, 0x42, 0x1c,
                    0xdc, 0x83, 0x20, 0x03, 0x00, 0x00 };
   int patcharea = FindMemory(0x510000, 0x570000, search);
   if (patcharea != 0) {
      int patchaddr = patcharea + 6;
/*
00541209       DC42 24                 FADD QWORD PTR DS:[EDX+24]
0054120C       90                      NOP
0054120D       90                      NOP
0054120E       90                      NOP
*/
      int patch[] = { 0xdc, 0x42, 0x24, 0x90, 0x90, 0x90 };
      PatchZone(patchaddr, patch);
   }
   else {
// build 406 (405+ is like this)
/*
.text:0055694D 8B 93 F8 02 00 00                 mov     edx, [ebx+2F8h]
.text:00556953 DD 42 1C                          fld     qword ptr [edx+1Ch]
.text:00556956 8B 54 24 20                       mov     edx, [esp+10h+arg_C]
.text:0055695A DC 83 20 03 00 00                 fadd    qword ptr [ebx+320h]
*/
      int search1a[] = { 0x02, 0x00, 0x00,
                        0xdd, 0x42, 0x1c,
                        0x8b, 0x54, 0x24, 0x20,
                        0xdc, 0x83, 0x20, 0x03, 0x00, 0x00 };
      patcharea = FindMemory(0x510000, 0x570000, search1a);
      if (patcharea != 0) {
         patchaddr = patcharea + 6;
      }
      int patch1[] = { 0xdc, 0x42, 0x24, 0x8b, 0x54, 0x24, 0x20, 0x90, 0x90, 0x90 };
      PatchZone(patchaddr, patch1);
   }
   if (patcharea == 0) {
      Print("Process already patched for variable spread or we just can't find the area to patch.");
      return;
   }
   

   
/*
00541532   |.  DD41 20                 |FLD QWORD PTR DS:[ECX+20]
00541535   |.  DC1D C05A5600           |FCOMP QWORD PTR DS:[565AC0]
0054153B   |.  DFE0                    |FSTSW AX
0054153D   |.  F6C4 41                 |TEST AH,41
00541540   |.  75 40                   |JNZ SHORT terminal.00541582
00541542   |.  4F                      |DEC EDI
00541543   |.  83C1 34                 |ADD ECX,34
00541546   |.  3BFB                    |CMP EDI,EBX
*/
   int search2[] = { 0xdf, 0xe0, 0xf6, 0xc4, 0x41, 0x75, 0x40, 0x4f, 0x83, 0xc1, 0x34, 0x3b, 0xfb };
   int patcharea2 = FindMemory(0x510000, 0x570000, search2);
   string volstr;
   if (patcharea2 != 0) {
      ProcessPatch(patcharea2 + 6, 0); // remove the volume check
      volstr = " Volume check removed at 0x" + Dec2Hex(patcharea2 + 6) + ".";
   }
   else {
      Print("Volume check NOT removed. You may encounter problems when spread is 0.");
   }
   Print("Process patched for variable spread at 0x" + Dec2Hex(patchaddr) + "." + volstr);
}

string Dec2Hex(int n) {
   string result = "";
   while(n > 0) {
      int d = n % 16;
      string c;
      if (d == 10) {
         c = "A";
      }
      else if (d == 11) {
         c = "B";
      }
      else if (d == 12) {
         c = "C";
      }
      else if (d == 13) {
         c = "D";
      }
      else if (d == 14) {
         c = "E";
      }
      else if (d == 15) {
         c = "F";
      }
      else {
         c = d;
      }
      result = c + result;
      n = n / 16;
   }
   return (result);
}

int MT4build() {
   int vSize, vInfo[];
   int hMod = GetModuleHandleA(0);
   int exePath[];
   ArrayResize(exePath, MAX_PATH/4);
   GetModuleFileNameA(hMod, exePath, MAX_PATH);
   string vChar[4];
   vSize = GetFileVersionInfoSizeA(exePath, 0);
   ArrayResize(vInfo, vSize / 4);
   GetFileVersionInfoA(exePath, 0, vSize, vInfo);
   string vString = "";
   for(int i = 0; i < vSize / 4; i++){
      vChar[0] = CharToStr(vInfo[i] & 0x000000FF);
      vChar[1] = CharToStr(vInfo[i] >>  8 & 0x000000FF);
      vChar[2] = CharToStr(vInfo[i] >> 16 & 0x000000FF);
      if(vChar[0] == "" && vChar[3] == "") vString = vString + " ";
      else vString = vString + vChar[0];
      vChar[3] = CharToStr(vInfo[i] >> 24 & 0x000000FF);
      if(vChar[1] == "" && vChar[0] == "") vString = vString + " ";
      else vString = vString + vChar[1];
      if(vChar[2] == "" && vChar[1] == "") vString = vString + " ";
      else vString = vString + vChar[2];
      if(vChar[3] == "" && vChar[2] == "") vString = vString + " ";
      else vString = vString + vChar[3];
   }
   vString = StringTrimRight(StringTrimLeft(StringSubstr(vString, StringFind(vString, "FileVersion") + 11, 15)));
   for (i = 0; i < 3; i++) {
      vString = StringSubstr(vString, StringFind(vString, ".") + 1);
   }
   int build = StrToInteger(vString);
   return (build);
}